extends Node

signal game_paused
signal game_unpaused

signal game_finished(elapsed: float, movement_count: int)

signal game_reset

var is_game_paused: bool = false

func toggle_pause():
	if is_game_paused:
		game_unpaused.emit()
	else:
		game_paused.emit()

	is_game_paused = !is_game_paused

func finish_game(elapsed: float, movement_count: int):
	game_finished.emit(elapsed, movement_count)

func reset_game():
	game_reset.emit()
