extends Area3D

var disks: Array

const disk_separation: float = 0.1

func _ready():
	reset()
	
# append_disk will append a new disk to this cylinder if the disk being appended is smaller than
# the frontmost in this cylinder
func append_disk(disk) -> bool:
	if can_append_disk(disk):
		disks.append(disk)
		#reposition_disks()
		disk.tween_to(self.get_position_for_disk(disk))
		return true
	return false
	
func can_append_disk(disk):
	return len(disks) == 0 or disks.back().size > disk.size

# pop_disks will return the backmost disk in this cylinder (the one at the top)
func pop_top_disk():
	if len(disks) > 0:
		return disks.pop_back()
		
	return null
	
# get_top_disk returns the disk object that is currently at the top
func get_top_disk():
	if len(disks) > 0:
		return disks.back()
	return null

# reposition_disks will iterate over all disks and reposition them
func reposition_disks():
	for n in range(disks.size()):
		disks[n].position = Vector3(self.position.x, disk_separation * n + (0.1*n + 0.2), 0)

func get_position_for_disk(disk) -> Vector3:
	for n in range(disks.size()):
		if disks[n].size == disk.size:
			return Vector3(self.position.x, disk_separation * n + (0.1*n + 0.2), 0)
	return Vector3.ZERO

func reset():
	disks = Array()
