extends Node3D

@export var size: int = 1

const radius_multiplier: float = 0.08
const base_size: float = 0.2

# Enable to let the disk follow the mouse
var follow_mouse: bool = false

func can_put_on_top(disk_size: int) -> bool: 
	return disk_size < size

# Called when the node enters the scene tree for the first time.
func _ready():
	get_node("shape").set_radius(base_size + (radius_multiplier*size))

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(_delta):
	if follow_mouse:
		var mouse_pos = get_viewport().get_mouse_position()
		var camera = get_viewport().get_camera_3d()
		var new_pos = camera.project_position(mouse_pos, camera.position.z)
		set_position(new_pos)
		return

func tween_to_position(destination: Vector3):
	var tween = get_tree().create_tween()
	tween.tween_property(
		self,
		"position",
		destination,
		0.2,
	)
	tween.play()
	
func tween_to(destination: Vector3):
	tween_to_position(destination)

func set_follow_mouse(value: bool):
	follow_mouse = value
