extends Node2D

const speed: float = 0.1

var to_lod: float

var action: int = 0 # 0 = none, 1 = blur, -1 = unblur

func _process(_delta):
	var mat = $Background.material
	var lod = mat.get("shader_parameter/lod")
	if (action == 1 and lod <= to_lod) or (action == -1 and lod >= to_lod):
		mat.set("shader_parameter/lod", lod + speed * action)
	$BlurText.text = "%.02f" % mat.get("shader_parameter/lod")

func _input(event):
	if event is InputEventKey and Input.is_key_pressed(KEY_O):
		blur()

	if event is InputEventKey and Input.is_key_pressed(KEY_P):
		unblur()

func blur():
	action = 1
	to_lod = 3
	
func unblur():
	action = -1
	to_lod = 0
